/*
    Programa: xadez.exe
    Descrio: biblioteca necessria para verificao do Xeque e Xeque mate.
    Programador: Eduardo Prates Albuquerque
    RGM: 21500
    Data da ltima modificao: 23/09/2016
*/

#include "func.h"                   /*Chama as funes de movimento e validao de movimento*/
#include <stdlib.h>					/* system(), sleep()*/
#include "xeque.h" 					/* escopo de funes, Defines*/
#include "conio_v3.2.4.h" 			/* Funo clrscr(), gotoxy() */


/*Funo que verifica se h Xeque no estado atual do jogo*/
int verifica_xeque(int M[][8],int vez,int x,int y,int atual_branco,int atual_preto)
{
int valida=0;
	if (M[x][y] != 0 )
        {
        	if (M[x][y] % 10 == 0)
            {
                valida=valida_movimento(x*10+y,atual_preto,M);
                if (valida==1)
                {
                    if (vez==1)
                    {
                        return -1;
                    }
                    else
                    {
                        return x*10+y;
                    }
                }
            }

            else if (M[x][y] % 10 == 1 )
            {
                valida=valida_movimento(x*10+y,atual_branco,M);
                if (valida==1)
                {
                    if (vez==0)
                    {
                        return -1;
                    }
		            else
                    {
                        return x*10+y;
                    }
                }
            }
	}
return -2;
}

/*Funo que verifica se houve Xeque Mate*/
int xeque_mate(int M[][8],int inimigo,int rei,int original_branco,int original_preto)
{
int inimigo_original,escapa_rei, mate=0,retorno=0;
int xeque,valida;
int x,y,time_rei,ameaca_original,guarda_melhor=0;
int a=0,b=0,res=0,amigo_rei=0,caminho=0,atual_branco,atual_preto;

ameaca_original=M[inimigo/10][inimigo%10];/*Guarda a posio inicial do inimigo*/
inimigo_original=0;
time_rei=M[rei/10][rei%10];
atual_branco=original_branco;
atual_preto=original_preto;

    /*Verifica se alguma pea amiga ou o prprio rei em Xeque, pode eliminar a pea que o ameaa */
   	for (x=0;x<8;x++)
    {
        for (y=0;y<8;y++)
        {
            retorno=0;
            /*Verifica se h alguma pea do mesmo time que o rei que est sendo atacado*/
            if (M[x][y]!= 0 && M[x][y] % 10 == M[rei/10][rei%10] % 10)
            {
                mate=valida_movimento(x*10+y,inimigo,M);
                if (mate == 1)
                {
                    /*atualiza a posicao do rei se ele for eliminar uma pea*/
                    if (M[x][y]==60)
                    {
                        atual_branco=inimigo;
                    }

                    else if (M[x][y]==61)
                    {
                        atual_preto=inimigo;
                    }
                    M[inimigo/10][inimigo%10]=M[x][y];
                    M[x][y]=0;

                    /*Verifica se a movimentao da pea que salvou o rei, no coloca o rei em outro Xeque*/
                    for (a=0;a<8;a++)
                    {
                        for (b=0;b<8;b++)
                        {
                            res=verifica_xeque(M,time_rei%10,a,b,atual_branco,atual_preto);
                            if (res == -1)
                            {
                                a=8;
                                b=8;
                                retorno=-1;
                            }
                        }
                    }
                    M[x][y]=M[inimigo/10][inimigo%10];
                    M[inimigo/10][inimigo%10]=ameaca_original;
                    atual_branco=original_branco;
                    atual_preto=original_preto;
                    if (retorno != -1)
                    {
                        return 100+x*10+y;
                    }
                }
            }
        }
    }

    inimigo_original=0;
    res=0;
    /*Verifica se o rei pode fugir do xeque mate, por meio da movimentao dele mesmo*/
    for (x=0;x<=7;x++)
    {
        for (y=0;y<=7;y++)
        {
            if ((valida=valida_movimento(rei,x*10+y,M) == 1))
            {
                if (M[x][y] != 0)
                {
                    inimigo_original=M[x][y];
                }
                M[x][y]=M[rei/10][rei%10];
                M[rei/10][rei%10]=0;

                /*Atualiza a posio do rei*/
                if (M[x][y] ==60)
                {
                    atual_branco=x*10+y;
                }
                else
                {
                    atual_preto=x*10+y;
                }

                /*Verifica se a nova posio ainda coloca o rei sob ataque*/
                for (a=0;a<=7;a++)
                {
                    for (b=0;b<=7;b++)
                    {
                        xeque=verifica_xeque(M,time_rei%10,a,b,atual_branco,atual_preto);
                        if (xeque == -1)
                        {
                            res=-1;
                        }
                    }
                }

                /*Retorna as peas ao lugar original*/
                M[rei/10][rei%10]=M[x][y];
                atual_branco=original_branco;
                atual_preto=original_preto;
                M[x][y]=inimigo_original;
                inimigo_original=0;

                /*Verifica se saiu do que Xeque com a opo*/
                if (res != -1)
                {
                    return 200+x*10+y;
                }
                else
                {
                    res=0;
                }
            }
        }
    }

    /*Verifica se alguma pea amiga pode se sacrificar pelo rei*/
    ameaca_original=inimigo;

     /*Verifica qual tipo de pea est atacando.Caso o bispo seja a amea*/
    if   (M[ameaca_original/10][ameaca_original%10]/10 == 2)
    {
        /*Se bispo est na diagonal - Esquerda cima*/
		if (rei/10 > ameaca_original/10 && rei%10 > ameaca_original%10 && ameaca_original%10 && rei-11 != ameaca_original)
		{
			caminho=rei-11;
		}
		/*Se bispo est na diagonal - Direita Baixo*/
		else if (rei/10 < ameaca_original/10 && rei%10 < ameaca_original%10 && ameaca_original%10 && rei+11 != ameaca_original)
		{
			caminho=rei+11;
		}
		/*Se bispo est na diagonal - Direita Cima*/
		else if (rei/10 > ameaca_original/10 && rei%10 < ameaca_original%10 && ameaca_original%10 && rei-9 != ameaca_original)
		{
			caminho=rei-9;
		}
		/*Se bispo est na diagonal - Esquerda Baixo*/
		else if (rei/10 < ameaca_original/10 && rei%10 > ameaca_original%10 && ameaca_original%10 && rei+9 != ameaca_original)
		{
			caminho=rei+9;
		}
    }
    /*Caso a torre seja a amea*/
    else if   (M[ameaca_original/10][ameaca_original%10]/10 == 4)
    {
        /*Se torre est acima*/
		if (rei/10 == ameaca_original/10 && rei%10 > ameaca_original%10 && rei-1 != ameaca_original)
		{
			caminho=rei-1;
		}
		/*Se torre est abaixo*/
		else if (rei/10 == ameaca_original/10 && rei%10 < ameaca_original%10 && rei+1 != ameaca_original)
		{
			caminho=rei+1;
		}
		/*Se torre est a esquerda*/
		else if (rei/10 > ameaca_original/10 && rei%10 == ameaca_original%10 && rei-10 != ameaca_original)
		{
			caminho=rei-10;
		}
		/*Se torre est a direita*/
		else if (rei/10 < ameaca_original/10 && rei%10 == ameaca_original%10 && rei+10 != ameaca_original)
		{
			caminho=rei+10;
		}
    }
    else if   (M[ameaca_original/10][ameaca_original%10]/10 == 5)
    {
        	/*Se rainha est acima*/
		if (rei/10 == ameaca_original/10 && rei%10 > ameaca_original%10 && rei-1 != ameaca_original)
		{
			caminho=rei-1;
		}
		/*Se rainha est abaixo*/
		else if (rei/10 == ameaca_original/10 && rei%10 < ameaca_original%10 && rei+1 != ameaca_original)
		{
			caminho=rei+1;
		}
		/*Se rainha est a esquerda*/
		else if (rei/10 > ameaca_original/10 && rei%10 == ameaca_original%10 && rei-10 != ameaca_original)
		{
			caminho=rei-10;
		}
		/*Se rainha est a direita*/
		else if (rei/10 < ameaca_original/10 && rei%10 == ameaca_original%10 && rei+10 != ameaca_original)
		{
			caminho=rei+10;
		}
		/*Se rainha est na diagonal - Esquerda cima*/
		if (rei/10 > ameaca_original/10 && rei%10 > ameaca_original%10 && ameaca_original%10 && rei-11 != ameaca_original)
		{
			caminho=rei-11;
		}
		/*Se rainha est na diagonal - Direita Baixo*/
		else if (rei/10 < ameaca_original/10 && rei%10 < ameaca_original%10 && ameaca_original%10 && rei+11 != ameaca_original)
		{
			caminho=rei+11;
		}
		/*Se rainha est na diagonal - Direita Cima*/
		else if (rei/10 > ameaca_original/10 && rei%10 < ameaca_original%10 && ameaca_original%10 && rei-9 != ameaca_original)
		{
			caminho=rei-9;
		}
		/*Se rainha est na diagonal - Esquerda Baixo*/
		else if (rei/10 < ameaca_original/10 && rei%10 > ameaca_original%10 && ameaca_original%10 && rei+9 != ameaca_original)
		{
			caminho=rei+9;
		}
    }

    if (caminho !=0)
    {
        for (x=0;x<8;x++)
        {
            for (y=0;y<8;y++)
            {
                /*Verifica se a pea  amiga do rei*/
                if (M[x][y] != 0 && M[x][y] %10 == M[rei/10][rei%10] %10 && M[x][y] != M[rei/10][rei%10])
                {
                    escapa_rei=valida_movimento(x*10+y,caminho,M);
                    if (escapa_rei == 1)
                    {
                        amigo_rei=x*10+y;
                        M[caminho/10][caminho%10]=M[x][y];
                        M[x][y]=0;
                        atual_branco=original_branco;
                        atual_preto=original_preto;

                        /*Verifica se o sacrficio impedir o Xeque Mate*/
                        for (a=0;a<8;a++)
                        {
                            for (b=0;b<8;b++)
                            {
                                mate=verifica_xeque(M,time_rei%10,a,b,atual_branco,atual_preto);
                                if (mate == -1)
                                {
                                        res=-1;
                                }
                            }
                        }

                        M[amigo_rei/10][amigo_rei%10]=M[caminho/10][caminho%10];
                        M[caminho/10][caminho%10]=0;

                        /*Verifica se saiu do que Xeque com a opo*/
                        if ((res != -1 && guarda_melhor ==0 )|| (res != -1 && M[guarda_melhor/10][guarda_melhor%10] > M[amigo_rei/10][amigo_rei%10]))
                        {
                            guarda_melhor=amigo_rei;
                        }
                         else
                        {
                            res=0;
                        }
                    }
                }
            }
        }
        if (guarda_melhor !=0)
        {
            return 30000+caminho*100+guarda_melhor;
        }
    }
return 0;
}

